

TACHYON
[~

{ TACHYON SPI Driver for  Digilent PmodSF2 PCM Memory  Nicholas G. Lordi
10/2012 }

: SPI.fth  ." Generic SPI Driver - 20121021.0000 " ;

''  Generic SPI Words based on Peter Jackabi's spi sd &  mcp3208 wordsets.

\ ( n1 -- )  n1 is the number of bits to be transmitted.
: SPCNT  3 COGREG!  ;

\ ( -- )  Executes kernel spi engine.
: SPIO  [SPIO] RUNMOD ;

\ ( -- b ) Leaves 1 byte on stack.
: SP@  -1 SPIO $FF AND  ;

\ ( b -- ) Sends 1 byte to device.
: SP!  #24 SHL SPIO DROP ;

\ ( w -- ) Sends 1 word to device.
: SP2!
    DUP #8 SHR SP! SP!  ;

\ ( a -- )  Sends 3 byte address to device.
: SP3!
    DUP 10 SHR SP! DUP 8 SHR SP! SP! ;

\ ( l -- ) Sends 1 long to device.
: SP4!
    #32 SPCNT SPIO DROP #8 SPCNT ;

\ ( -- w ) Leaves 1 word on stack.
: SP2@
   SP@  #8 SHL SP@ OR  ;

\ ( -- a ) Leaves 3 bytes on stack.
: SP3@
   #24 SPCNT -1 SPIO  8 SPCNT $FFFFFF AND ;

\ ( -- l) Leaves 1 long on stack.
: SP4@
   #32  SPCNT -1 SPIO  8 SPCNT $FFFFFFFF AND   ;

]~
END
