TACHYON
{  
			UPDATED 20121203.2000 BBR
			UPDATED 20121201.1800 BB Riley, Underhill Center, VT
			CREATED	20121001.0000 Nicholas Lordi, Manasquan, NJ
			
                 TACHYON V2.1   um-FPU64 Access     

   See uM-FPU64 Datasheet and Instruction Set for details.  }
             

: FPU64opcodes.fth ." List of opcodes as constants - 20121203.2000" ;

{ 
	The following FPU64 operations are defined as constants for convenience.
	Only those operations required for a specific application need be loaded.

	FPU Instructions - Selected Operations

	The following instructions require no additional parameters. They 
	only use registers 0 & A.
}

$10	CONSTANT	#START
$20	CONSTANT	#STOP




$DC	CONSTANT	#rtc
$00 CONSTANT	#noop
$F0 CONSTANT	#sync
$5C CONSTANT	#synchar  \ not an instruction
$B8 CONSTANT	#lstatusa
$F1 CONSTANT	#rdstatus
$F2	CONSTANT	#readstring
$F3	CONSTANT	#version
$FF	CONSTANT	#reset		\  9 consecutive $FFs is A SOFT RESET          

$04 CONSTANT	#clra
$05 CONSTANT	#clrx
$06 CONSTANT	#clr0
$60 CONSTANT	#float

$61 CONSTANT	#fix
$62 CONSTANT	#fixr
$64 CONSTANT	#fsplit
$0B CONSTANT	#loada
$0C CONSTANT	#loadx
$0F CONSTANT	#xsavea
$29 CONSTANT	#fset0
$9C CONSTANT	#lset0
$EF CONSTANT	#strdec
$D2 CONSTANT	#adctrig

$5D CONSTANT	#loade
$5E CONSTANT	#loadpi
$4E CONSTANT	#degrees
$4F CONSTANT	#radians

$E3	CONSTANT	#strset
$E5	CONSTANT	#strins
$EA	CONSTANT	#strtof
$EB	CONSTANT	#strtol

$41 CONSTANT	#sqrt
$42	CONSTANT	#root
$43 CONSTANT	#ln
$44 CONSTANT	#log
$45 CONSTANT	#e
$46 CONSTANT	#exp10
$3E CONSTANT	#fneg
$3F CONSTANT	#fabs
$BC CONSTANT	#labs
$40 CONSTANT	#finv
$47 CONSTANT	#sin
$48 CONSTANT	#cos
$49 CONSTANT	#tan
$2A CONSTANT	#fadd0
$22 CONSTANT	#fsub0
$2C CONSTANT	#fsubr0
$2D CONSTANT	#fmul0
$2E CONSTANT	#fdiv0
$2F CONSTANT	#fdivr0

\  The following instructions require output of an immediate following byte,
\  which refers to a register number, unless stated otherwise.

$01 CONSTANT	#selecta
$02 CONSTANT	#selectx
$08 CONSTANT	#copya
$09 CONSTANT	#copyx
$10 CONSTANT	#copy0
$13 CONSTANT	#swapa
$DE CONSTANT	#xsave
$7E CONSTANT	#fcall

$D1 CONSTANT	#adcmode  \ mode byte
$D3 CONSTANT	#adcscale \ 0|1 channel no.
$D4 CONSTANT	#adclong  \ 0|1 channel no.
$CF CONSTANT	#fserin   \ type of operation
$1F CONSTANT	#ftoa     \ format type
$9B CONSTANT	#ltoa     \ format type
$DB CONSTANT	#delay    \ millisec
$56 CONSTANT	#fcnv     \ type of conversion

\  the following instructions also require an immediate following compound
\  byte with or without following bytes.

$D0 CONSTANT	#digio
$DA CONSTANT	#devio
$CE CONSTANT	#fserout

\ The following instructions require immediate output of a long.

$93 CONSTANT	#lwrite0
$91 CONSTANT	#lwritea
$92 CONSTANT	#lwritex

\ The following instructions require immediate output of 2 bytes.

$07 CONSTANT	#copy
$CE CONSTANT	#fserout
$E4 CONSTANT	#strsel

\ The following instructions expect 4 bytes to be read immediately following the instruction.

$97 CONSTANT	#lread0
$95 CONSTANT	#lreada
$96 CONSTANT	#lreadx


END

