TACHYON

\  ---------------- LCD -------------------------------

: LCD.fth ." small serial LCD toolset on pin 6 - 20121203.1200" ;

	{ The "?" in the various string prints, is the escape character for 
	  Peter Anderson Serial LCD firmware }

: LCDEMIT	6 SEROUT ;
: LCD		' LCDEMIT uemit W! ;

: BACKLIGHT	( on/off -- ) IF ." ?BE0" ELSE ." ?B00" THEN ;	
									\  This must be used with console redirected
									\  to the LCD. "LCD ON BACKLIGHT CON" or insert
									\  "ON BACKLIGHT" into a section of code already
									\  bracketed by  "LCD ... CON"

: HOME	( -- ) ." ?a" ;				\  "home" cursor (0,0)
: CLS	( -- ) ." ?f" ;				\  clear screen, then home cursor
: LCDNL		( -- ) ." ?n" ;				\  go to start of next line

: LCDXY		( x y -- ) ." ?x" $020A .NUM ." ?y" $010A .NUM ;
										\  cursor to (x,y)
										
: @LCD ( geometry brightness -- )
		LCD
		CLS
		2 seconds
		." ?G" $030A .NUM	#250 ms
		." ?B" .BYTE		#500 ms
		CLS
		CON
		;
END
